#define  UNI_HANDLE_BAD -496
#define  UNI_NO_DEFAULT -499
#define  UNI_TRY_LATER  -488

#define  UnicodeSignature 0x53494e55            /* UNIS */
#define  STATIC_RULES_TABLE  0x00008000


extern   int   NWGetLocalToUnicodeHandle( LONG *handle);
extern   int   NWGetUnicodeToLocalHandle( LONG *handle);
extern   int   NWGetMonocaseHandle( LONG *handle);

extern   LONG LoadRules(
               LONG codePage,
               LONG countryID,
               LONG flags,
               LONG *ruleHandle,
               struct ResourceTagStructure *resourceTag);

extern   LONG OverrideDefaultRules(
               LONG codePage,
               LONG countryID);

extern   LONG UnloadRules(
               LONG rulesHandle,
               struct ResourceTagStructure *RTag);

extern   LONG FlushRulesTables(
               LONG *ruleTablesLoaded,
               LONG *ruleTablesFlushed);


extern   unicode *unicpy(unicode *dest, unicode *src);
extern   unsigned unilen(unicode *s);
extern   unsigned unisize(unicode *s);
extern   unsigned uninlen(unicode *s, unsigned maxLen);
extern   int unicmp(unicode *s1, unicode *s2);
extern   int uniicmp(unicode *s1, unicode *s2);
extern   int uninicmp(unicode *s1, unicode *s2, unsigned len);
extern   unicode *unichr(unicode *s, int c);
extern   unicode *unipbrk(unicode *s1, unicode *s2);
extern   unicode *unicat(unicode *s1, unicode *s2);
extern   unicode *uniindex(unicode *s, unicode *srch);
extern   unicode *unincat(unicode *s1, unicode *s2, unsigned n);
extern   unicode *unincpy(unicode *s1, unicode *s2, unsigned n);

extern   int LocalToUnicode(char *localChars, unsigned maxUniChars, unicode *uniChars);
extern   int UnicodeToLocal(unicode *uniChars, unsigned maxLocalChars, char *localChars);
extern   unicode MonoCase(unicode uniChar);

extern   int  NWUnicodeToMonocase(
               LONG rulesHandle,
               unicode *out,
               LONG size,
               unicode *in,
               LONG *len);

extern   int  NWLocalToUnicode(
               LONG rulesHandle,
               unicode *out,
               LONG size,
               unsigned char *in,
               unicode noMap,
               LONG *len,
               LONG allowNoMapFlag);

extern   int  NWUnicodeToCollation(
               LONG rulesHandle,
               unicode *out,
               LONG size,
               unicode *in,
               unicode noMap,
               LONG *len);

extern int  NWUnicodeToLocal(
               LONG rulesHandle,
               unsigned char *out,
               LONG size,
               unicode *in,
               char noMap,
               LONG *len,
               LONG allowNoMapFlag);

extern int UnicodeToKeyword(
            unicode *uniChars,
            unsigned maxKeywordChars,
            char *keywordChars);

extern int KeywordToUnicode(
            char *keywordChars,
            unsigned maxUniChars,
            unicode *uniChars);


